======================================================
import java.util.Arrays;

public class Queue {
    private String[] queue;
    private int size;

    public Queue(int capacity) {
        queue = new String[capacity];
    }

    public void add(String s) {
        if (queue.length == size()) {
            String[] buffer = new String[queue.length * 2];
            for (int i = 0; i < queue.length; i++) {
                buffer[i] = queue[i];
            }
            queue = buffer;
        }
        queue[size()] = s;
        size++;
    }

    public String poll() {
        if (size() > 0) {
            String ret = queue[0];
            queue[0] = null;
            for (int i = 1; i < queue.length; i++) {
                queue[i - 1] = queue[i];
            }
            queue[queue.length - 1] = null;
            size--;
            return ret;
        }
        return null;
    }

    public int size() {
        return size;
    }

    @Override
    public String toString() {
        return "Queue{" +
                "queue=" + Arrays.toString(queue) +
                ", size=" + size +
                '}';
    }
}
======================================================
public class SingleLinkedList {
    private Node head;
    private Node tail;
    private int size;

    public SingleLinkedList() {
        this.head = null;
        this.tail = null;
        this.size = 0;
    }

    public void addFirst(String s) {
        if (head == null) {
            head = new Node(s, null);
            tail = head;
        } else {
            head = new Node(s, head);
        }
        size++;
    }

    public void addLast(String point) {
        if (head == null) {
            head = new Node(point, null);
            tail = head;
        } else {
            Node newNode = new Node(point, null);
            Node oldTail = tail;
            oldTail.next = newNode;
            tail = newNode;
        }
        size++;
    }

    public String pollFirst() {
        String ret = head.data;
        head = head.next;
        // TODO check if head and tail are equal if size is less than 2
        size--;
        return ret;

    }

    public String pollLast() {
        String ret = tail.data;
        Node current = head;
        while (current.next != tail) {
            current = current.next;
        }
        current.next = null;
        tail = current;
        size--;
        return ret;
    }

    public void add(int i, String s) {
        Node current = head;
        if (i == 0)
            addFirst(s);
        else if (i >= size)
            addLast(s);
        else {
            int idx = 0;
            while (current != null && idx < i - 1) {
                current = current.next;
                idx++;
            }
            Node node = new Node(s, current.next);
            current.next = node;
            size++;
        }
    }

    @Override
    public String toString() {
        return "SingleLinkedList{" +
                "head=" + head +
                ", tail=" + tail +
                ", size=" + size +
                '}';
    }

    private class Node {
        String data;
        Node next;

        public Node(String data, Node next) {
            this.data = data;
            this.next = next;
        }

        @Override
        public String toString() {
            return "Node{" +
                    "data='" + data + '\'' +
                    ", next=" + next +
                    '}';
        }
    }
}
======================================================
public class DoubleLinkedList {
    private Node head;
    private Node tail;
    private int size;

    public DoubleLinkedList(){
        this.head = null;
        this.tail = null;
        this.size = 0;
    }

    public void addFirst(String s) {
        Node newNode = new Node(s, null, this.head);
        if (head == null){
            tail = newNode;
			head = newNode;
		}else{
            head.prev = newNode;
			head = newNode;
		}
        size++;
    }

    public void addLast(String s) {
        Node newNode = new Node(s, this.tail, null);
        if (tail == null)
            head = newNode;
        else
            tail.next = newNode;
        tail = newNode;
        size++;
    }

    public String pollFirst() {
        if (size() == 0)
            return null;
        String ret = head.data;
        head = head.next;
        if (head != null)
            head.prev = null;
        else
            tail = null;

        size--;
        return ret;
    }

    public String pollLast() {
        if (size() == 0)
            return null;
        String ret = tail.data;
        tail = tail.prev;
        if (tail != null)
            tail.next = null;
        else
            head = null;
        size--;
        return ret;
    }

    public void add(int i, String s) {
        if (i == 0) {
            addFirst(s);
        } else if (i == size()) {
            addLast(s);
        } else {
            Node current = head;
            for (int j = 0; j < i - 1; j++)
                current = current.next;
            Node newNode = new Node(s, current, current.next);
            current.next.prev = newNode;
            current.next = newNode;
            size++;
        }
    }

    public String remove(int i) {
        Node removed;
        if (i == 0) {
            removed = head;
            head = head.next;
            if (head != null)
                head.prev = null;
            else
                tail = null;
        } else if (i == size() - 1) {
            removed = tail;
            tail = tail.prev;
            tail.next = null;
        } else {
            Node current = head;
            for (int j = 0; j < i; j++) {
                current = current.next;
            }
            removed = current;
            current.prev.next = current.next;
            current.next.prev = current.prev;
        }

        size--;
        return removed.data;
    }

    public int size() {
        return size;
    }

    public void printList(){
        Node current = head;
        System.out.print("DoubleLinkedList");
        while(current.next != null){
            System.out.print("{ current: " + current.data + ", ");
            System.out.print("next: " + current.next.data + " }");
            current = current.next;
        }
        System.out.print("size: " + size);
    }

    class Node {
        String data;
        Node prev;
        Node next;

        public Node(String data, Node prev, Node next) {
            this.data = data;
            this.prev = prev;
            this.next = next;
        }
    }
}
======================================================
public class Map {
    private MapEntry[] map;
    private int size;

    public Map(int size) {
        this.map = new MapEntry[size];
        this.size = 0;
    }

    public String put(String key, String value) {
        if (size() > 0) {
            for (int i = 0; i < map.length; i++) {
                if (map[i] != null) {
                    if (map[i].key.compareTo(key) == 0) {
                        String ret = map[i].value;
                        map[i].value = value;
                        return ret;
                    }
                }
            }
        }
        if (map.length == size()) {
            MapEntry[] buffer = new MapEntry[map.length * 2];
            for (int i = 0; i < map.length; i++) {
                buffer[i] = new MapEntry(map[i].key, map[i].value);
            }
            map = buffer;
        }
        map[size()] = new MapEntry(key, value);
        size++;
        return null;
    }

    public String remove(String key) {
        for (int i = 0; i < map.length; i++) {
            if (map[i] != null) {
                if (key.compareTo(map[i].key) == 0) {
                    String ret = map[i].value;
                    map[i] = null;
                    for (int j = 1; j < map.length; j++)
                        map[j - 1] = map[j];
                    size--;
                    return ret;
                }
            }
        }
        return null;
    }

    public int size() {
        return size;
    }

    @Override
    public String toString() {
        return "Map{" +
                "map=" + Arrays.toString(map) +
                ", size=" + size +
                '}';
    }

    private class MapEntry {
        String key;
        String value;

        public MapEntry(String key, String value) {
            this.key = key;
            this.value = value;
        }

        @Override
        public String toString() {
            return "MapEntry{" +
                    "key='" + key + '\'' +
                    ", value='" + value + '\'' +
                    '}';
        }
    }

}
======================================================
public class BinaryTree {

    private TreeNode root;

    public BinaryTree(){
        this.root = null;
    }

    public String put(String key, String value) {
        if (root == null) {
            root = new TreeNode(key, value);
            return null;
        }
        return put(key, value, root);
    }

    private String put(String key, String value, TreeNode root) {
        int compare = key.compareTo(root.key);
        if (compare < 0) {
            if (root.left == null) {
                root.left = new TreeNode(key, value);
                return null;
            } else {
                return put(key, value, root.left);
            }
        } else if (compare > 0) {
            if (root.right == null) {
                root.right = new TreeNode(key, value);
                return null;
            } else {
                return put(key, value, root.right);
            }
        } else {
            String ret = root.value;
            root.value = value;
            return ret;
        }
    }

    public String get(String key) {
        TreeNode ret = get(key, root);
        if (ret != null)
            return ret.value;
        return null;
    }

    public TreeNode get(String key, TreeNode root) {
        if (root == null)
            return null;
        int compare = key.compareTo(root.key);
        if (compare < 0)
            return get(key, root.left);
        else if (compare > 0)
            return get(key, root.right);
        else
            return root;

    }

    public int size() {
        return size(root);
    }

    private int size(TreeNode root) {
        if (root == null)
            return 0;
        else
            return (size(root.left) + 1 + size(root.right));

    }

    @Override
    public String toString() {
        return "BinaryTree{" +
                "root=" + root + ", " +
                "size=" + size() +
                '}';
    }

    private class TreeNode {
        String key;
        String value;
        TreeNode left;
        TreeNode right;

        public TreeNode(String key, String value) {
            this.key = key;
            this.value = value;
        }

        @Override
        public String toString() {
            return "TreeNode{" +
                    "key='" + key + '\'' +
                    ", value='" + value + '\'' +
                    ", left=" + left +
                    ", right=" + right +
                    '}';
        }
    }
}
======================================================
public class TreeSet {

    private TreeNode root;

    // Initialises 'this' as an empty set.
    public TreeSet() {
        this.root = null;
    }

    // Ensures that the specified element is contained in this set. If the element already
    // existed in this set, the method does not change the set and returns 'false'. Returns
    // 'true' if the set was changed as a result of the call.
    // Precondition: element != null.
    public boolean add(String element) {
        if (root == null) {
            root = new TreeNode(element.hashCode(), element, null, null);
            return true;
        }
        return root.add(element);
    }

    // Returns true if this set contains the specified element, as determined by
    // object identity. More formally, returns 'true' if and only if this set contains
    // an object 'e' such that element == e.
    // Precondition: element != null.
    public boolean contains(String element) {
        if (root == null)
            return false;
        return root.contains(element);
    }

    @Override
    public String toString() {
        return "TreeSet{" +
                "root=" + root +
                '}';
    }

    private class TreeNode {
        private int key;
        private String value;
        private TreeNode left;
        private TreeNode right;

        public TreeNode(int key, String value, TreeNode left, TreeNode right) {
            this.key = key;
            this.value = value;
            this.left = left;
            this.right = right;
        }

        @Override
        public String toString() {
            return "TreeNode{" +
                    "key=" + key +
                    ", value='" + value + '\'' +
                    ", left=" + left +
                    ", right=" + right +
                    '}';
        }

        public boolean add(String insert) {
            int current = insert.hashCode();
            if (this.value.equals(insert))
                return false;
            if (current <= this.key) {
                if (left != null) {
                    return left.add(insert);
                } else {
                    left = new TreeNode(current, insert, null, null);
                    return true;
                }
            } else {
                if (right != null) {
                    return right.add(insert);
                } else {
                    right = new TreeNode(current, insert, null, null);
                    return true;
                }
            }
        }

        public boolean contains(String element) {
            int current = element.hashCode();
            if (this.value.equals(element))
                return true;
            if (current <= this.key) {
                if (left != null)
                    return left.contains(element);
                else
                    return false;
            } else {
                if (right != null)
                    return right.contains(element);
                else
                    return false;
            }
        }
    }
}

